Subject: bug#40118: 27.0.90; Signing emails with gpg

From: Robert Pluim <[email-masked]>
Date: Wed, 15 Apr 2020 18:37:51 +0200

>>>>> On Tue, 14 Apr 2020 13:10:50 +0200, Štěpán Němec <[email-masked]> said:

    >> When I have -
    >> --8<---------------cut here---------------start------------->8---
    >> (add-hook 'gnus-message-setup-hook 'mml-secure-message-sign)
    >> (add-hook 'message-setup-hook 'mml-secure-message-sign)
    >> 
    >> enabled in emacs26.3 up pops a pinentry box and I input my code and the message sends.
    >> 
    >> However in 27.0.90 I get this crash report -
    >> 
    >> Debugger entered--Lisp error: (error "Couldn’t find any signer names; try setting `mml-s...")
    >> signal(error ("Couldn’t find any signer names; try setting `mml-s..."))
    >> error("Couldn't find any signer names%s" "; try setting `mml-secure-smime-sign-with-sender'.")
    >> mml-secure-epg-sign(OpenPGP t)
    >> mml2015-epg-sign((part (sign . "pgpmime") (tag-location . 297) (contents . "\ntesting 1\n  \n-- \nA taste of linux = http://www.sh...")))
    >> mml2015-sign((part (sign . "pgpmime") (tag-location . 297) (contents . "\ntesting 1\n  \n-- \nA taste of linux = http://www.sh...")))
    >> mml-pgpmime-sign-buffer((part (sign . "pgpmime") (tag-location . 297) (contents . "\ntesting 1\n  \n-- \nA taste of linux = http://www.sh...")))
    >> mml-generate-mime-1((part (sign . "pgpmime") (tag-location . 297) (contents . "\ntesting 1\n  \n-- \nA taste of linux = http://www.sh...")))
    >> mml-generate-mime(nil nil)
    >> message-encode-message-body()
    >> message-send-mail(nil)
    >> message-send-via-mail(nil)
    >> message-send(nil)
    >> message-send-and-exit(nil)
    >> funcall-interactively(message-send-and-exit nil)
    >> call-interactively(message-send-and-exit)
    >> orgtbl-ctrl-c-ctrl-c(nil)
    >> funcall-interactively(orgtbl-ctrl-c-ctrl-c nil)
    >> call-interactively(orgtbl-ctrl-c-ctrl-c nil nil)
    >> command-execute(orgtbl-ctrl-c-ctrl-c)
    >> --8<---------------cut here---------------end--------------->8---
    >> 
    >> And when looking through the pdf's I built after installing 27.0.90 I can't find how to set 'mml-secure-smime-sign-with-sender''
    >>

Click on the 'customize' link shown in the help buffer that pops up
when you do 'C-h v mml-secure-smime-sign-with-sender RET'

    >> How can I return to the behaviour of 26.3, but still use 27.0.90, as
    >> the only way that I can now send emails is by disabling the 2 lines I
    >> showed earlier.

    Štěpán> You can set `mml-secure-smime-sign-with-sender' (or any other option)
    Štěpán> using the command `customize-variable' or simply putting

    Štěpán>   (setq mml-secure-smime-sign-with-sender t)

mml-secure-smime-sign-with sender has no effect when signing with pgp,
you'd need to set mml-secure-openpgp-sign-with-sender.

I can adjust the message easily enough, but I honestly think both of
those variables should default to t, not nil. And I think we should do
that in emacs-27 [1]. Eli?

(and we should implement a more sophisticated form of 'mm-sign-option'
'guided in master).

Robert

Footnotes:
[1]  Power users will already have set or know how to set
     'mml-secure-openpgp-signers' and the like